<!-- Header -->
<div fxLayout="row">
  <div fxFlex="50%">
    <h1>Welcome administrator!</h1>
    <h3>Create or view users...</h3>
  </div>
  <div fxFlex="50%">
    <app-admin-routing></app-admin-routing>
  </div>
</div>
<!-- /Header -->

<!-- Loading Spinner-->
<div class="spinner-container" *ngIf="!ready">
  <div class="spinner-container-content">
    <md-spinner color="warn"></md-spinner>
  </div>
</div>
<!-- /Loading Spinner-->

<!-- Form -->
<div class='admin-create-user-form'>
  <form [formGroup]="userForm" autocomplete='off'>

    <!-- Roles -->
    <div fxLayout="row">
      <md-radio-group formControlName="role">
        <md-radio-button value="HUNGRY">User is hungry</md-radio-button>
        <md-radio-button value="CHEF">User is chef</md-radio-button>
      </md-radio-group>
    </div>
    <!-- /Roles -->

    <!-- First row (First name - Last name - Email) -->
    <div fxLayout="row">
      <md-input-container fxFlex='35%' class="form-input">
        <input mdInput type="text" placeholder="First name" formControlName="firstName">
        <md-error *ngIf="userForm.get('firstName').hasError('minlength') && (userForm.get('firstName').touched)">Minimum of 2 characters</md-error>
        <md-error *ngIf="userForm.get('firstName').hasError('maxlength') && (userForm.get('firstName').touched || userForm.get('lastName').dirty )">Maximum of 25 characters</md-error>
        <md-error *ngIf="userForm.get('firstName').hasError('pattern') && (userForm.get('firstName').touched ||userForm.get('firstName').dirty )">Invalid characters</md-error>
        <md-error *ngIf="userForm.get('firstName').hasError('required') && (userForm.get('firstName').touched)">First name is required</md-error>
      </md-input-container>
      <md-input-container fxFlex='35%' class="form-input">
        <input mdInput type="text" placeholder="Last name" formControlName="lastName">
        <md-error *ngIf="userForm.get('lastName').hasError('minlength') && (userForm.get('lastName').touched)">Minimum of 2 characters</md-error>
        <md-error *ngIf="userForm.get('lastName').hasError('maxlength') && (userForm.get('lastName').touched || userForm.get('lastName').dirty)">Maximum of 25 characters</md-error>
        <md-error *ngIf="userForm.get('lastName').hasError('pattern') && (userForm.get('lastName').touched || userForm.get('lastName').dirty)">Invalid characters</md-error>
        <md-error *ngIf="userForm.get('lastName').hasError('required') && (userForm.get('lastName').touched )">Last name is required</md-error>
      </md-input-container>
      <md-input-container fxFlex='30%' class="form-input">
        <input mdInput type="text" placeholder="Email" formControlName="email">
        <md-error *ngIf="userForm.get('email').hasError('required') && (userForm.get('email').touched || userForm.get('email').dirty)">Email is required</md-error>
        <md-error *ngIf="userForm.get('email').hasError('pattern') && (userForm.get('email').touched ) && !userForm.get('email').hasError('required')">Invalid email</md-error>
      </md-input-container>
    </div>
    <!-- /First row (First name - Last name - Email) -->

    <!-- Second row (Password - Confirm password - Submit button) -->
    <div fxLayout="row">
      <md-input-container fxFlex='35%' class="form-input">
        <input mdInput type='password' placeholder="Password" formControlName="password">
        <md-error *ngIf="userForm.get('password').hasError('minlength') && (userForm.get('password').touched)">Minimum of 6 characters</md-error>
        <md-error *ngIf="userForm.get('password').hasError('maxlength') && (userForm.get('password').touched || userForm.get('password').dirty)">Maximum of 25 characters</md-error>
        <md-error *ngIf="userForm.get('password').hasError('required') && (userForm.get('password').touched || userForm.get('password').dirty)">Password is required</md-error>
      </md-input-container>

      <md-input-container fxFlex='35%' class="form-input">
        <input mdInput type='password' placeholder="Confirm password" formControlName="confirmPassword" (blur)="blurred = true;"
          (focus)="blurred = false;">
        <md-error *ngIf="userForm.get('confirmPassword').hasError('required') ">Password confirmation is required</md-error>
        <md-error *ngIf="userForm.get('confirmPassword').hasError('validateStart')
                            || (userForm.get('confirmPassword').hasError('validateEqual') && blurred )&& !userForm.get('confirmPassword').hasError('required')">
          Password missmatch</md-error>
      </md-input-container>

      <div class='submit-button' fxFlex='30%'>
        <button md-button type="button" color="primary" class="button-strong-text" (click)="onSubmit()" [disabled]="disableSubmit || userForm.invalid || submitting">Create user</button>
      </div>
    </div>
    <!-- /Second row (Password - Confirm password - Submit button) -->

    <!-- Third row (Password restriction - Terms and Privacy) -->
    <div fxlayout="row">
      <span fxFlex="70%" class="small-text">Must be at least 6 characters</span>
      <span fxFlex="30%" class="small-text">
        By clicking  Create user, I agree to the <span (click)="displayTermsAndPolicy(true)" class="clickable">Terms of Service</span>      and <span (click)="displayTermsAndPolicy(false)" class="clickable">Privacy Policy</span>
      </span>
    </div>
    <!-- /Third row (Password restriction - Terms and Privacy) -->

  </form>

  <!-- Spinner -->
  <div *ngIf="submitting">
    <md-spinner color="warn" class="small-md-spinner"></md-spinner>
  </div>
  <!-- /Spinner -->

</div>
<!-- /Form -->

<!-- controls -->
<div>
  <h1>User list</h1>
  <div fxLayout="row">
    <div fxFlex="10%">
      <md-select placeholder="Page size" [ngModel]='selectedPageSize' (change)="changePageSize($event)" id="pageSize">
        <md-option *ngFor="let pageOption of pageOptions" [value]="pageOption">{{pageOption}}
        </md-option>
      </md-select>
    </div>

    <div fxFlex="15%">
      <md-select placeholder="Order by" [ngModel]='orderby' (change)="changeOrder($event)" id="orderby">
        <md-option [value]="orderByOptionsVal[0]"> {{orderByOptions[0]}}</md-option>
        <md-option [value]="orderByOptionsVal[1]"> {{orderByOptions[1]}}</md-option>
        <md-option [value]="orderByOptionsVal[2]"> {{orderByOptions[2]}}</md-option>
        <md-option [value]="orderByOptionsVal[3]"> {{orderByOptions[3]}}</md-option>
      </md-select>
    </div>

    <div fxFlex="35%">
      <button md-mini-fab color="accent" (click)="changeSortingAsc()" [disabled]="(sort==='asc')" title="Sort ascending"><i class="material-icons">arrow_upward</i></button>
      <button md-mini-fab color="accent" (click)="changeSortingDesc()" [disabled]="(sort==='desc')" title="Sort descending"><i class="material-icons">arrow_downward</i></button>
    </div>

    <div fxFlex="40%" fxLayoutAlign="end">
      <app-shared-pagination *ngIf="ready" [pageSize]="selectedPageSize" [totalPages]="totalPages" [currentPage]="currentPage"
        (updatePage)="pageChanged($event)"></app-shared-pagination>
    </div>
  </div>
</div>
<!-- /Controls -->

<!-- Users -->
<div *ngFor="let user of users">
  <app-admin-user [user]="user" (userDeleted)="updatePage()"></app-admin-user>
</div>
<!-- /Users -->

<!-- Controls -->
<div fxLayout="row">
  <div fxFlex="40%" fxFlexOffset="60%" fxLayoutAlign="end">
    <app-shared-pagination *ngIf="ready" [pageSize]="selectedPageSize" [totalPages]="totalPages" [currentPage]="currentPage"
      (updatePage)="pageChanged($event)"></app-shared-pagination>
  </div>
</div>
<!-- /Controls -->
